/* ***** BEGIN LICENSE BLOCK *****
 * Distributed under the BSD license:
 *
 * Copyright (c) 2010, Ajax.org B.V.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of Ajax.org B.V. nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL AJAX.ORG B.V. BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * ***** END LICENSE BLOCK ***** */

define(["require","exports","module","./lib/oop","./lib/event_emitter"],function(f,g){var h=f("./lib/oop"),i=f("./lib/event_emitter").EventEmitter,j=g.Anchor=function(d,b,a){this.$onChange=this.onChange.bind(this);this.attach(d);"undefined"==typeof a?this.setPosition(b.row,b.column):this.setPosition(b,a)};(function(){h.implement(this,i);this.getPosition=function(){return this.$clipPositionToDocument(this.row,this.column)};this.getDocument=function(){return this.document};this.$insertRight=!1;this.onChange=
function(d){var d=d.data,b=d.range;if(!(b.start.row==b.end.row&&b.start.row!=this.row)&&!(b.start.row>this.row)&&!(b.start.row==this.row&&b.start.column>this.column)){var a=this.row,e=this.column,c=b.start,b=b.end;"insertText"===d.action?c.row===a&&c.column<=e?c.column===e&&this.$insertRight||(c.row===b.row?e+=b.column-c.column:(e-=c.column,a+=b.row-c.row)):c.row!==b.row&&c.row<a&&(a+=b.row-c.row):"insertLines"===d.action?c.row===a&&0===e&&this.$insertRight||c.row<=a&&(a+=b.row-c.row):"removeText"===
d.action?c.row===a&&c.column<e?e=b.column>=e?c.column:Math.max(0,e-(b.column-c.column)):c.row!==b.row&&c.row<a?(b.row===a&&(e=Math.max(0,e-b.column)+c.column),a-=b.row-c.row):b.row===a&&(a-=b.row-c.row,e=Math.max(0,e-b.column)+c.column):"removeLines"==d.action&&c.row<=a&&(b.row<=a?a-=b.row-c.row:(a=c.row,e=0));this.setPosition(a,e,!0)}};this.setPosition=function(d,b,a){d=a?{row:d,column:b}:this.$clipPositionToDocument(d,b);this.row==d.row&&this.column==d.column||(b={row:this.row,column:this.column},
this.row=d.row,this.column=d.column,this._signal("change",{old:b,value:d}))};this.detach=function(){this.document.removeEventListener("change",this.$onChange)};this.attach=function(d){this.document=d||this.document;this.document.on("change",this.$onChange)};this.$clipPositionToDocument=function(d,b){var a={};d>=this.document.getLength()?(a.row=Math.max(0,this.document.getLength()-1),a.column=this.document.getLine(a.row).length):0>d?(a.row=0,a.column=0):(a.row=d,a.column=Math.min(this.document.getLine(a.row).length,
Math.max(0,b)));0>b&&(a.column=0);return a}}).call(j.prototype)});