/* ***** BEGIN LICENSE BLOCK *****
 * Distributed under the BSD license:
 *
 * Copyright (c) 2012, Ajax.org B.V.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of Ajax.org B.V. nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL AJAX.ORG B.V. BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * ***** END LICENSE BLOCK ***** */

define("require exports module ../line_widgets ../lib/dom ../range".split(" "),function(k,r){var s=k("../line_widgets").LineWidgets,m=k("../lib/dom"),o=k("../range").Range;r.showErrorMarker=function(a,l){var i=a.session;i.widgetManager||(i.widgetManager=new s(i),i.widgetManager.attach(a));var h=a.getCursorPosition(),b=h.row,e=i.lineWidgets&&i.lineWidgets[b];e?e.destroy():b-=l;a:{var f=i.getAnnotations().sort(o.comparePoints);if(f.length){var c;b:{c={row:b,column:-1};for(var g=o.comparePoints,j=0,
k=f.length-1;j<=k;){var n=j+k>>1,p=g(c,f[n]);if(0<p)j=n+1;else if(0>p)k=n-1;else{c=n;break b}}c=-(j+1)}0>c&&(c=-c-1);c>=f.length-1?c=0<l?0:f.length-1:0===c&&0>l&&(c=f.length-1);if((g=f[c])&&l){if(g.row===b){do g=f[c+=l];while(g&&g.row===b);if(!g){b=f.slice();break a}}j=[];b=g.row;do j[0>l?"unshift":"push"](g),g=f[c+=l];while(g&&g.row==b);b=j.length&&j;break a}}b=void 0}if(b)e=b[0],h.column=(e.pos&&"number"!=typeof e.column?e.pos.sc:e.column)||0,h.row=e.row,e=a.renderer.$gutterLayer.$annotations[h.row];
else{if(e)return;e={text:["Looks good!"],className:"ace_ok"}}a.session.unfold(h.row);a.selection.moveToPosition(h);var d={row:h.row,fixedWidth:!0,coverGutter:!0,el:m.createElement("div")},b=d.el.appendChild(m.createElement("div")),f=d.el.appendChild(m.createElement("div"));f.className="error_widget_arrow "+e.className;h=a.renderer.$cursorLayer.getPixelPosition(h).left;f.style.left=h+a.renderer.gutterWidth-5+"px";d.el.className="error_widget_wrapper";b.className="error_widget "+e.className;b.innerHTML=
e.text.join("<br>");b.appendChild(m.createElement("div"));var q=function(a,b,c){if(0===b&&("esc"===c||"return"===c))return d.destroy(),{command:"null"}};d.destroy=function(){a.$mouseHandler.isMousePressed||(a.keyBinding.removeKeyboardHandler(q),i.widgetManager.removeLineWidget(d),a.off("changeSelection",d.destroy),a.off("changeSession",d.destroy),a.off("mouseup",d.destroy),a.off("change",d.destroy))};a.keyBinding.addKeyboardHandler(q);a.on("changeSelection",d.destroy);a.on("changeSession",d.destroy);
a.on("mouseup",d.destroy);a.on("change",d.destroy);a.session.widgetManager.addLineWidget(d);d.el.onmousedown=a.focus.bind(a);a.renderer.scrollCursorIntoView(null,0.5,{bottom:d.el.offsetHeight})};m.importCssString("    .error_widget_wrapper {        background: inherit;        color: inherit;        border:none    }    .error_widget {        border-top: solid 2px;        border-bottom: solid 2px;        margin: 5px 0;        padding: 10px 40px;        white-space: pre-wrap;    }    .error_widget.ace_error, .error_widget_arrow.ace_error{        border-color: #ff5a5a    }    .error_widget.ace_warning, .error_widget_arrow.ace_warning{        border-color: #F1D817    }    .error_widget.ace_info, .error_widget_arrow.ace_info{        border-color: #5a5a5a    }    .error_widget.ace_ok, .error_widget_arrow.ace_ok{        border-color: #5aaa5a    }    .error_widget_arrow {        position: absolute;        border: solid 5px;        border-top-color: transparent!important;        border-right-color: transparent!important;        border-left-color: transparent!important;        top: -5px;    }",
"")});