/* ***** BEGIN LICENSE BLOCK *****
 * Distributed under the BSD license:
 *
 * Copyright (c) 2012, Ajax.org B.V.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of Ajax.org B.V. nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL AJAX.ORG B.V. BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * ***** END LICENSE BLOCK ***** */

define("require exports module ../snippets ../autocomplete ../config ../lib/lang ../autocomplete/util ../autocomplete/text_completer ../editor ../config".split(" "),function(e,f){function k(a){var b=a.getCursorPosition(),d=a.session.getLine(b.row),c=l.retrievePrecedingIdentifier(d,b.column);a.completers.forEach(function(a){a.identifierRegexps&&a.identifierRegexps.forEach(function(a){!c&&a&&(c=l.retrievePrecedingIdentifier(d,b.column,a))})});return c}var c=e("../snippets").snippetManager,i=e("../autocomplete").Autocomplete,
t=e("../config"),m=e("../lib/lang"),l=e("../autocomplete/util"),h=e("../autocomplete/text_completer"),n={getCompletions:function(a,b,d,c,e){if(b.$mode.completer)return b.$mode.completer.getCompletions(a,b,d,c,e);a=a.session.getState(d.row);b=b.$mode.getCompletions(a,b,d,c);e(null,b)}},o={getCompletions:function(a,b,d,e,f){var h=c.snippetMap,g=[];c.getActiveScopes(a).forEach(function(a){for(var a=h[a]||[],b=a.length;b--;){var d=a[b],c=d.name||d.tabTrigger;c&&g.push({caption:c,snippet:d.content,meta:d.tabTrigger&&
!d.name?d.tabTrigger+"\u21e5 ":"snippet",type:"snippet"})}},this);f(null,g)},getDocTooltip:function(a){"snippet"==a.type&&!a.docHTML&&(a.docHTML=["<b>",m.escapeHTML(a.caption),"</b><hr></hr>",m.escapeHTML(a.snippet)].join(""))}},g=[o,h,n];f.setCompleters=function(a){g=a||[]};f.addCompleter=function(a){g.push(a)};f.textCompleter=h;f.keyWordCompleter=n;f.snippetCompleter=o;var p={name:"expandSnippet",exec:function(a){return c.expandWithTab(a)},bindKey:"Tab"},j=function(a,b){q(b.session.$mode)},q=function(a){var b=
a.$id;c.files||(c.files={});r(b);a.modes&&a.modes.forEach(q)},r=function(a){if(a&&!c.files[a]){var b=a.replace("mode","snippets");c.files[a]={};t.loadModule(b,function(b){b&&(c.files[a]=b,!b.snippets&&b.snippetText&&(b.snippets=c.parseSnippetFile(b.snippetText)),c.register(b.snippets||[],b.scope),b.includeScopes&&(c.snippetMap[b.scope].includeScopes=b.includeScopes,b.includeScopes.forEach(function(a){r("ace/mode/"+a)})))})}},s=function(a){var b=a.editor,c=b.completer&&b.completer.activated;"backspace"===
a.command.name?c&&!k(b)&&b.completer.detach():"insertstring"===a.command.name&&(k(b)&&!c)&&(b.completer||(b.completer=new i),b.completer.autoSelect=!1,b.completer.autoInsert=!1,b.completer.showPopup(b))},h=e("../editor").Editor;e("../config").defineOptions(h.prototype,"editor",{enableBasicAutocompletion:{set:function(a){a?(this.completers||(this.completers=Array.isArray(a)?a:g),this.commands.addCommand(i.startCommand)):this.commands.removeCommand(i.startCommand)},value:!1},enableLiveAutocompletion:{set:function(a){a?
(this.completers||(this.completers=Array.isArray(a)?a:g),this.commands.on("afterExec",s)):this.commands.removeListener("afterExec",s)},value:!1},enableSnippets:{set:function(a){a?(this.commands.addCommand(p),this.on("changeMode",j),j(null,this)):(this.commands.removeCommand(p),this.off("changeMode",j))},value:!1}})});