/* ***** BEGIN LICENSE BLOCK *****
 * Distributed under the BSD license:
 *
 * Copyright (c) 2010, Ajax.org B.V.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of Ajax.org B.V. nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL AJAX.ORG B.V. BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * ***** END LICENSE BLOCK ***** */

define(["require","exports","module","../lib/lang"],function(q,c){var o=q("../lib/lang");c.$detectIndentation=function(a){for(var b=[],g=[],c=0,i=0,j=Math.min(a.length,1E3),e=0;e<j;e++){var f=a[e];if(/^\s*[^*+\-\s]/.test(f)){"\t"==f[0]&&c++;var d=f.match(/^ */)[0].length;if(d&&"\t"!=f[d]){var h=d-i;0<h&&(!(i%h)&&!(d%h))&&(g[h]=(g[h]||0)+1);b[d]=(b[d]||0)+1}for(i=d;e<j&&"\\"==f[f.length-1];)f=a[e++]}}a=g.reduce(function(a,b){return a+b},0);f=j=i=0;for(e=1;12>e;e++){d=0;for(h=e;h<b.length;h+=e)d+=b[h]||
0;1==e?(f=d,d=b[1]?0.9:0.8,b.length||(d=0)):d/=f;g[e]&&(d+=g[e]/a);d>i&&(i=d,j=e)}if(i&&1.4<i)var n=j;if(c>f+1)return{ch:"\t",length:n};if(f>c+1)return{ch:" ",length:n}};c.detectIndentation=function(a){var b=a.getLines(0,1E3),b=c.$detectIndentation(b)||{};b.ch&&a.setUseSoftTabs(" "==b.ch);b.length&&a.setTabSize(b.length);return b};c.trimTrailingSpace=function(a,b){for(var g=a.getDocument(),c=g.getAllLines(),i=b?-1:0,j=0,e=c.length;j<e;j++){var f=c[j],d=f.search(/\s+$/);d>i&&g.removeInLine(j,d,f.length)}};
c.convertIndentation=function(a,b,c){var p=a.getTabString()[0],i=a.getTabSize();c||(c=i);b||(b=p);for(var p="\t"==b?b:o.stringRepeat(b,c),j=a.doc,e=j.getAllLines(),f={},d={},h=0,n=e.length;h<n;h++){var m=e[h].match(/^\s*/)[0];if(m){var l=a.$getStringScreenWidth(m)[0],k=Math.floor(l/i),l=l%i,k=f[k]||(f[k]=o.stringRepeat(p,k)),k=k+(d[l]||(d[l]=o.stringRepeat(" ",l)));k!=m&&(j.removeInLine(h,0,m.length),j.insertInLine({row:h,column:0},k))}}a.setTabSize(c);a.setUseSoftTabs(" "==b)};c.$parseStringArg=
function(a){var b={};/t/.test(a)?b.ch="\t":/s/.test(a)&&(b.ch=" ");if(a=a.match(/\d+/))b.length=parseInt(a[0],10);return b};c.$parseArg=function(a){return!a?{}:"string"==typeof a?c.$parseStringArg(a):"string"==typeof a.text?c.$parseStringArg(a.text):a};c.commands=[{name:"detectIndentation",exec:function(a){c.detectIndentation(a.session)}},{name:"trimTrailingSpace",exec:function(a){c.trimTrailingSpace(a.session)}},{name:"convertIndentation",exec:function(a,b){var g=c.$parseArg(b);c.convertIndentation(a.session,
g.ch,g.length)}},{name:"setIndentation",exec:function(a,b){var g=c.$parseArg(b);g.length&&a.session.setTabSize(g.length);g.ch&&a.session.setUseSoftTabs(" "==g.ch)}}]});