/* ***** BEGIN LICENSE BLOCK *****
 * Distributed under the BSD license:
 *
 * Copyright (c) 2010, Ajax.org B.V.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of Ajax.org B.V. nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL AJAX.ORG B.V. BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * ***** END LICENSE BLOCK ***** */

define(["require","exports","module","./keys","./useragent"],function(l,c){function m(a,d,b){var c=n(d);if(!h.isMac&&g){if(g[91]||g[92])c|=8;if(g.altGr)if(3!=(3&c))g.altGr=0;else return;if(18===b||17===b){var e="location"in d?d.location:d.keyLocation;17===b&&1===e?j=d.timeStamp:18===b&&(3===c&&2===e)&&(e=-j,j=d.timeStamp,e+=j,3>e&&(g.altGr=!0))}}b in k.MODIFIER_KEYS&&(b=-1);if(c&8&&(91===b||93===b))b=-1;if(!c&&13===b&&(e="location"in d?d.location:d.keyLocation,3===e&&(a(d,c,-b),d.defaultPrevented)))return;
if(h.isChromeOS&&c&8){a(d,c,b);if(d.defaultPrevented)return;c&=-9}return!c&&!(b in k.FUNCTION_KEYS)&&!(b in k.PRINTABLE_KEYS)?!1:a(d,c,b)}var k=l("./keys"),h=l("./useragent");c.addListener=function(a,c,b){if(a.addEventListener)return a.addEventListener(c,b,!1);if(a.attachEvent){var f=function(){b.call(a,window.event)};b._wrapper=f;a.attachEvent("on"+c,f)}};c.removeListener=function(a,c,b){if(a.removeEventListener)return a.removeEventListener(c,b,!1);a.detachEvent&&a.detachEvent("on"+c,b._wrapper||
b)};c.stopEvent=function(a){c.stopPropagation(a);c.preventDefault(a);return!1};c.stopPropagation=function(a){a.stopPropagation?a.stopPropagation():a.cancelBubble=!0};c.preventDefault=function(a){a.preventDefault?a.preventDefault():a.returnValue=!1};c.getButton=function(a){return"dblclick"==a.type?0:"contextmenu"==a.type||h.isMac&&a.ctrlKey&&!a.altKey&&!a.shiftKey?2:a.preventDefault?a.button:{1:0,2:2,4:1}[a.button]};c.capture=function(a,d,b){function f(a){d&&d(a);b&&b(a);c.removeListener(document,
"mousemove",d,!0);c.removeListener(document,"mouseup",f,!0);c.removeListener(document,"dragstart",f,!0)}c.addListener(document,"mousemove",d,!0);c.addListener(document,"mouseup",f,!0);c.addListener(document,"dragstart",f,!0);return f};c.addMouseWheelListener=function(a,d){"onmousewheel"in a?c.addListener(a,"mousewheel",function(b){void 0!==b.wheelDeltaX?(b.wheelX=-b.wheelDeltaX/8,b.wheelY=-b.wheelDeltaY/8):(b.wheelX=0,b.wheelY=-b.wheelDelta/8);d(b)}):"onwheel"in a?c.addListener(a,"wheel",function(b){switch(b.deltaMode){case b.DOM_DELTA_PIXEL:b.wheelX=
0.35*b.deltaX||0;b.wheelY=0.35*b.deltaY||0;break;case b.DOM_DELTA_LINE:case b.DOM_DELTA_PAGE:b.wheelX=5*(b.deltaX||0),b.wheelY=5*(b.deltaY||0)}d(b)}):c.addListener(a,"DOMMouseScroll",function(b){b.axis&&b.axis==b.HORIZONTAL_AXIS?(b.wheelX=5*(b.detail||0),b.wheelY=0):(b.wheelX=0,b.wheelY=5*(b.detail||0));d(b)})};c.addMultiMouseDownListener=function(a,d,b,f){var e=0,o,g,i,j={2:"dblclick",3:"tripleclick",4:"quadclick"};c.addListener(a,"mousedown",function(a){0!==c.getButton(a)?e=0:1<a.detail?(e++,4<
e&&(e=1)):e=1;if(h.isIE){var k=5<Math.abs(a.clientX-o)||5<Math.abs(a.clientY-g);if(!i||k)e=1;i&&clearTimeout(i);i=setTimeout(function(){i=null},d[e-1]||600);1==e&&(o=a.clientX,g=a.clientY)}a._clicks=e;b[f]("mousedown",a);if(4<e)e=0;else if(1<e)return b[f](j[e],a)});h.isOldIE&&c.addListener(a,"dblclick",function(a){e=2;i&&clearTimeout(i);i=setTimeout(function(){i=null},d[e-1]||600);b[f]("mousedown",a);b[f](j[e],a)})};var n=h.isMac&&h.isOpera&&!("KeyboardEvent"in window)?function(a){return 0|(a.metaKey?
1:0)|(a.altKey?2:0)|(a.shiftKey?4:0)|(a.ctrlKey?8:0)}:function(a){return 0|(a.ctrlKey?1:0)|(a.altKey?2:0)|(a.shiftKey?4:0)|(a.metaKey?8:0)};c.getModifierString=function(a){return k.KEY_MODS[n(a)]};var g=null,j=0;c.addCommandKeyListener=function(a,d){var b=c.addListener;if(h.isOldGecko||h.isOpera&&!("KeyboardEvent"in window)){var f=null;b(a,"keydown",function(a){f=a.keyCode});b(a,"keypress",function(a){return m(d,a,f)})}else{var e=null;b(a,"keydown",function(a){g[a.keyCode]=!0;var b=m(d,a,a.keyCode);
e=a.defaultPrevented;return b});b(a,"keypress",function(a){if(e&&(a.ctrlKey||a.altKey||a.shiftKey||a.metaKey))c.stopEvent(a),e=null});b(a,"keyup",function(a){g[a.keyCode]=null});g||(g=Object.create(null),b(window,"focus",function(){g=Object.create(null)}))}};window.postMessage&&!h.isOldIE&&(c.nextTick=function(a,d){d=d||window;c.addListener(d,"message",function f(e){"zero-timeout-message-1"==e.data&&(c.stopPropagation(e),c.removeListener(d,"message",f),a())});d.postMessage("zero-timeout-message-1",
"*")});c.nextFrame=window.requestAnimationFrame||window.mozRequestAnimationFrame||window.webkitRequestAnimationFrame||window.msRequestAnimationFrame||window.oRequestAnimationFrame;c.nextFrame=c.nextFrame?c.nextFrame.bind(window):function(a){setTimeout(a,17)}});