/* ***** BEGIN LICENSE BLOCK *****
 * Distributed under the BSD license:
 *
 * Copyright (c) 2010, Ajax.org B.V.
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of Ajax.org B.V. nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL AJAX.ORG B.V. BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * ***** END LICENSE BLOCK ***** */

define(["require","exports","module"],function(h,d){d.last=function(a){return a[a.length-1]};d.stringReverse=function(a){return a.split("").reverse().join("")};d.stringRepeat=function(a,c){for(var b="";0<c;)if(c&1&&(b+=a),c>>=1)a+=a;return b};var f=/^\s\s*/,g=/\s\s*$/;d.stringTrimLeft=function(a){return a.replace(f,"")};d.stringTrimRight=function(a){return a.replace(g,"")};d.copyObject=function(a){var c={},b;for(b in a)c[b]=a[b];return c};d.copyArray=function(a){for(var c=[],b=0,d=a.length;b<d;b++)c[b]=
a[b]&&"object"==typeof a[b]?this.copyObject(a[b]):a[b];return c};d.deepCopy=function(a){if("object"!==typeof a||!a)return a;var c=a.constructor;if(c===RegExp)return a;var c=c(),b;for(b in a)c[b]="object"===typeof a[b]?d.deepCopy(a[b]):a[b];return c};d.arrayToMap=function(a){for(var c={},b=0;b<a.length;b++)c[a[b]]=1;return c};d.createMap=function(a){var c=Object.create(null),b;for(b in a)c[b]=a[b];return c};d.arrayRemove=function(a,c){for(var b=0;b<=a.length;b++)c===a[b]&&a.splice(b,1)};d.escapeRegExp=
function(a){return a.replace(/([.*+?^${}()|[\]\/\\])/g,"\\$1")};d.escapeHTML=function(a){return a.replace(/&/g,"&#38;").replace(/"/g,"&#34;").replace(/'/g,"&#39;").replace(/</g,"&#60;")};d.getMatchOffsets=function(a,c){var b=[];a.replace(c,function(a){b.push({offset:arguments[arguments.length-2],length:a.length})});return b};d.deferredCall=function(a){var c=null,b=function(){c=null;a()},d=function(a){d.cancel();c=setTimeout(b,a||0);return d};d.schedule=d;d.call=function(){this.cancel();a();return d};
d.cancel=function(){clearTimeout(c);c=null;return d};d.isPending=function(){return c};return d};d.delayedCall=function(a,c){var b=null,d=function(){b=null;a()},e=function(a){null==b&&(b=setTimeout(d,a||c))};e.delay=function(a){b&&clearTimeout(b);b=setTimeout(d,a||c)};e.schedule=e;e.call=function(){this.cancel();a()};e.cancel=function(){b&&clearTimeout(b);b=null};e.isPending=function(){return b};return e}});