/* ***** BEGIN LICENSE BLOCK *****
 * Distributed under the BSD license:
 *
 * Copyright (c) 2010, Ajax.org B.V.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of Ajax.org B.V. nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL AJAX.ORG B.V. BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * ***** END LICENSE BLOCK ***** */

define("require exports module ./lib/oop ./lib/dom ./range".split(" "),function(i,l){function j(a){this.session=a;this.session.widgetManager=this;this.session.getRowLength=this.getRowLength;this.session.$getWidgetScreenLength=this.$getWidgetScreenLength;this.updateOnChange=this.updateOnChange.bind(this);this.renderWidgets=this.renderWidgets.bind(this);this.measureWidgets=this.measureWidgets.bind(this);this.session._changedWidgets=[];this.$onChangeEditor=this.$onChangeEditor.bind(this);this.session.on("change",
this.updateOnChange);this.session.on("changeEditor",this.$onChangeEditor)}i("./lib/oop");var k=i("./lib/dom");i("./range");(function(){this.getRowLength=function(a){var b;b=this.lineWidgets?this.lineWidgets[a]&&this.lineWidgets[a].rowCount||0:0;return!this.$useWrapMode||!this.$wrapData[a]?1+b:this.$wrapData[a].length+1+b};this.$getWidgetScreenLength=function(){var a=0;this.lineWidgets.forEach(function(b){b&&b.rowCount&&(a+=b.rowCount)});return a};this.$onChangeEditor=function(a){this.attach(a.editor)};
this.attach=function(a){a&&(a.widgetManager&&a.widgetManager!=this)&&a.widgetManager.detach();if(this.editor!=a&&(this.detach(),this.editor=a))a.widgetManager=this,a.renderer.on("beforeRender",this.measureWidgets),a.renderer.on("afterRender",this.renderWidgets)};this.detach=function(){var a=this.editor;a&&(this.editor=null,a.widgetManager=null,a.renderer.off("beforeRender",this.measureWidgets),a.renderer.off("afterRender",this.renderWidgets),(a=this.session.lineWidgets)&&a.forEach(function(a){a&&
(a.el&&a.el.parentNode)&&(a._inDocument=!1,a.el.parentNode.removeChild(a.el))}))};this.updateOnChange=function(a){var b=this.session.lineWidgets;if(b){var d=a.data,e=d.range,a=e.start.row,e=e.end.row-a;0!==e&&("removeText"==d.action||"removeLines"==d.action?b.splice(a+1,e).forEach(function(a){a&&this.removeLineWidget(a)},this):(d=Array(e),d.unshift(a,0),b.splice.apply(b,d)),this.$updateRows())}};this.$updateRows=function(){var a=this.session.lineWidgets;if(a){var b=!0;a.forEach(function(a,e){a&&(b=
!1,a.row=e)});b&&(this.session.lineWidgets=null)}};this.addLineWidget=function(a){this.session.lineWidgets||(this.session.lineWidgets=Array(this.session.getLength()));this.session.lineWidgets[a.row]=a;var b=this.editor.renderer;a.html&&!a.el&&(a.el=k.createElement("div"),a.el.innerHTML=a.html);a.el&&(k.addCssClass(a.el,"ace_lineWidgetContainer"),a.el.style.position="absolute",a.el.style.zIndex=5,b.container.appendChild(a.el),a._inDocument=!0);a.coverGutter||(a.el.style.zIndex=3);a.pixelHeight||(a.pixelHeight=
a.el.offsetHeight);null==a.rowCount&&(a.rowCount=a.pixelHeight/b.layerConfig.lineHeight);this.session._emit("changeFold",{data:{start:{row:a.row}}});this.$updateRows();this.renderWidgets(null,b);return a};this.removeLineWidget=function(a){a._inDocument=!1;a.el&&a.el.parentNode&&a.el.parentNode.removeChild(a.el);if(a.editor&&a.editor.destroy)try{a.editor.destroy()}catch(b){}this.session.lineWidgets&&(this.session.lineWidgets[a.row]=void 0);this.session._emit("changeFold",{data:{start:{row:a.row}}});
this.$updateRows()};this.onWidgetChanged=function(a){this.session._changedWidgets.push(a);this.editor&&this.editor.renderer.updateFull()};this.measureWidgets=function(a,b){var d=this.session._changedWidgets,e=b.layerConfig;if(d&&d.length){for(var g=Infinity,h=0;h<d.length;h++){var c=d[h];c._inDocument||(c._inDocument=!0,b.container.appendChild(c.el));c.h=c.el.offsetHeight;c.fixedWidth||(c.w=c.el.offsetWidth,c.screenWidth=Math.ceil(c.w/e.characterWidth));var f=c.h/e.lineHeight;c.coverLine&&(f-=this.session.getRowLineCount(c.row),
0>f&&(f=0));c.rowCount!=f&&(c.rowCount=f,c.row<g&&(g=c.row))}Infinity!=g&&(this.session._emit("changeFold",{data:{start:{row:g}}}),this.session.lineWidgetWidth=null);this.session._changedWidgets=[]}};this.renderWidgets=function(a,b){var d=b.layerConfig,e=this.session.lineWidgets;if(e){for(var g=Math.min(this.firstRow,d.firstRow),h=Math.max(this.lastRow,d.lastRow,e.length);0<g&&!e[g];)g--;this.firstRow=d.firstRow;this.lastRow=d.lastRow;for(b.$cursorLayer.config=d;g<=h;g++){var c=e[g];if(c&&c.el){c._inDocument||
(c._inDocument=!0,b.container.appendChild(c.el));var f=b.$cursorLayer.getPixelPosition({row:g,column:0},!0).top;c.coverLine||(f+=d.lineHeight*this.session.getRowLineCount(c.row));c.el.style.top=f-d.offset+"px";f=c.coverGutter?0:b.gutterWidth;c.fixedWidth||(f-=b.scrollLeft);c.el.style.left=f+"px";c.el.style.right=c.fixedWidth?b.scrollBar.getWidth()+"px":""}}}}}).call(j.prototype);l.LineWidgets=j});