/* ***** BEGIN LICENSE BLOCK *****
 * Distributed under the BSD license:
 *
 * Copyright (c) 2010, Ajax.org B.V.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of Ajax.org B.V. nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL AJAX.ORG B.V. BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * ***** END LICENSE BLOCK ***** */

define("require exports module ../../lib/oop ../behaviour ../../token_iterator ../../lib/lang".split(" "),function(g,j){function f(a,d){return-1<a.type.lastIndexOf(d+".xml")}var k=g("../../lib/oop"),l=g("../behaviour").Behaviour,h=g("../../token_iterator").TokenIterator;g("../../lib/lang");var i=function(){this.add("string_dquotes","insertion",function(a,d,e,b,c){if('"'==c||"'"==c){a=b.doc.getTextRange(e.getSelectionRange());if(""!==a&&"'"!==a&&'"'!=a&&e.getWrapBehavioursEnabled())return{text:c+a+
c,selection:!1};a=e.getCursorPosition();e=b.doc.getLine(a.row).substring(a.column,a.column+1);a=new h(b,a.row,a.column);b=a.getCurrentToken();if(e==c&&(f(b,"attribute-value")||f(b,"string")))return{text:"",selection:[1,1]};b||(b=a.stepBackward());if(b){for(;f(b,"tag-whitespace")||f(b,"whitespace");)b=a.stepBackward();a=!e||e.match(/\s/);if(f(b,"attribute-equals")&&(a||">"==e)||f(b,"decl-attribute-equals")&&(a||"?"==e))return{text:c+c,selection:[1,1]}}}});this.add("string_dquotes","deletion",function(a,
d,e,b,c){a=b.doc.getTextRange(c);if(!c.isMultiLine()&&('"'==a||"'"==a)&&b.doc.getLine(c.start.row).substring(c.start.column+1,c.start.column+2)==a)return c.end.column++,c});this.add("autoclosing","insertion",function(a,d,e,b,c){if(">"==c&&(a=e.getCursorPosition(),b=new h(b,a.row,a.column),(d=b.getCurrentToken()||b.stepBackward())&&(f(d,"tag-name")||f(d,"tag-whitespace")||f(d,"attribute-name")||f(d,"attribute-equals")||f(d,"attribute-value"))&&!f(d,"reference.attribute-value"))){if(f(d,"attribute-value")&&
(e=d.value.charAt(0),'"'==e||"'"==e)){var c=d.value.charAt(d.value.length-1),g=b.getCurrentTokenColumn()+d.value.length;if(g>a.column||g==a.column&&e!=c)return}for(;!f(d,"tag-name");)d=b.stepBackward();e=b.getCurrentTokenRow();c=b.getCurrentTokenColumn();if(!f(b.stepBackward(),"end-tag-open")&&(b=d.value,e==a.row&&(b=b.substring(0,a.column-c)),!this.voidElements.hasOwnProperty(b.toLowerCase())))return{text:"></"+b+">",selection:[1,1]}}});this.add("autoindent","insertion",function(a,d,e,b,c){if("\n"==
c&&(a=e.getCursorPosition(),d=b.getLine(a.row),e=new h(b,a.row,a.column),(c=e.getCurrentToken())&&-1!==c.type.indexOf("tag-close"))){for(;c&&-1===c.type.indexOf("tag-name");)c=e.stepBackward();if(c){var f=c.value,d=e.getCurrentTokenRow();if((c=e.stepBackward())&&-1===c.type.indexOf("end-tag")&&this.voidElements&&!this.voidElements[f])return a=b.getTokenAt(a.row,a.column+1),d=b.getLine(d),d=this.$getIndent(d),b=d+b.getTabString(),a&&"</"===a.value?{text:"\n"+b+"\n"+d,selection:[1,b.length,1,b.length]}:
{text:"\n"+b}}}})};k.inherits(i,l);j.XmlBehaviour=i});