/* ***** BEGIN LICENSE BLOCK *****
 * Distributed under the BSD license:
 *
 * Copyright (c) 2010, Ajax.org B.V.
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of Ajax.org B.V. nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL AJAX.ORG B.V. BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * ***** END LICENSE BLOCK ***** */

define("require exports module ../lib/oop ../lib/lang ./text_highlight_rules".split(" "),function(i,k){var l=i("../lib/oop"),m=i("../lib/lang"),n=i("./text_highlight_rules").TextHighlightRules,j=function(){this.$rules={start:[{tokenNames:["c9searchresults.constant.numeric","c9searchresults.text","c9searchresults.text","c9searchresults.keyword"],regex:"(^\\s+[0-9]+)(:\\s)(.+)",onMatch:function(c,h,g){var a=this.splitRegex.exec(c),c=this.tokenNames,h=[{type:c[0],value:a[1]},{type:c[1],value:a[2]}],
g=g[1],a=a[3],d,e=0;if(g&&g.exec)for(g.lastIndex=0;d=g.exec(a);){var f=a.substring(e,d.index),e=g.lastIndex;f&&h.push({type:c[2],value:f});if(d[0])h.push({type:c[3],value:d[0]});else if(!f)break}e<a.length&&h.push({type:c[2],value:a.substr(e)});return h}},{token:["string","text"],regex:"(\\S.*)(:$)"},{regex:"Searching for .*$",onMatch:function(c,h,g){var a=c.split("\u0001");if(3>a.length)return"text";var d,e,f,b=0,c=[{value:a[b++]+"'",type:"text"},{value:e=a[b++],type:"text"},{value:"'"+a[b++],type:"text"}];
" in"!==a[2]&&(f=a[b],c.push({value:"'"+a[b++]+"'",type:"text"},{value:a[b++],type:"text"}));c.push({value:" "+a[b++]+" ",type:"text"});a[b+1]?(d=a[b+1],c.push({value:"("+a[b+1]+")",type:"text"}),b+=1):b-=1;for(;b++<a.length;)a[b]&&c.push({value:a[b],type:"text"});f&&(e=f,d="");e&&(/regex/.test(d)||(e=m.escapeRegExp(e)),/whole/.test(d)&&(e="\\b"+e+"\\b"));if(f=e)a:{d=/ sensitive/.test(d)?"g":"ig";try{f=RegExp("("+e+")",d);break a}catch(i){}f=void 0}if(d=f)g[0]=h,g[1]=d;return c}},{regex:"\\d+",token:"constant.numeric"}]}};
l.inherits(j,n);k.C9SearchHighlightRules=j});