/* ***** BEGIN LICENSE BLOCK *****
 * Distributed under the BSD license:
 *
 * Copyright (c) 2010, Ajax.org B.V.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of Ajax.org B.V. nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL AJAX.ORG B.V. BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * ***** END LICENSE BLOCK ***** */

define("require exports module ../lib/oop ./text ./clojure_highlight_rules ./matching_parens_outdent".split(" "),function(b,i){var j=b("../lib/oop"),k=b("./text").Mode,l=b("./clojure_highlight_rules").ClojureHighlightRules,m=b("./matching_parens_outdent").MatchingParensOutdent,g=function(){this.HighlightRules=l;this.$outdent=new m};j.inherits(g,k);(function(){this.lineCommentStart=";";this.minorIndentFunctions="defn defn- defmacro def deftest testing".split(" ");this.$toIndent=function(a){return a.split("").map(function(a){return/\s/.exec(a)?
a:" "}).join("")};this.$calculateIndent=function(a,h){for(var c=this.$getIndent(a),e=0,b,d,f=a.length-1;0<=f&&!(d=a[f],"("===d?(e--,b=!0):"("===d||"["===d||"{"===d?(e--,b=!1):(")"===d||"]"===d||"}"===d)&&e++,0>e);f--);if(0>e&&b){c=f+=1;for(e="";;){d=a[f];if(" "===d||"\t"===d)return-1!==this.minorIndentFunctions.indexOf(e)?this.$toIndent(a.substring(0,c-1)+h):this.$toIndent(a.substring(0,f+1));if(void 0===d)return this.$toIndent(a.substring(0,c-1)+h);e+=a[f];f++}}else{if(0>e&&!b)return this.$toIndent(a.substring(0,
f+1));0<e&&(c=c.substring(0,c.length-h.length));return c}};this.getNextLineIndent=function(a,b,c){return this.$calculateIndent(b,c)};this.checkOutdent=function(a,b,c){return this.$outdent.checkOutdent(b,c)};this.autoOutdent=function(a,b,c){this.$outdent.autoOutdent(b,c)};this.$id="ace/mode/clojure"}).call(g.prototype);i.Mode=g});