/* ***** BEGIN LICENSE BLOCK *****
 * Distributed under the BSD license:
 *
 * Copyright (c) 2010, Ajax.org B.V.
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of Ajax.org B.V. nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL AJAX.ORG B.V. BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * ***** END LICENSE BLOCK ***** */

define("require exports module ./coffee_highlight_rules ./matching_brace_outdent ./folding/coffee ../range ./text ../worker/worker_client ../lib/oop".split(" "),function(c,g){function e(){this.HighlightRules=h;this.$outdent=new i;this.foldingRules=new j}var h=c("./coffee_highlight_rules").CoffeeHighlightRules,i=c("./matching_brace_outdent").MatchingBraceOutdent,j=c("./folding/coffee").FoldMode,k=c("../range").Range,l=c("./text").Mode,m=c("../worker/worker_client").WorkerClient;c("../lib/oop").inherits(e,
l);(function(){var c=/(?:[({[=:]|[-=]>|\b(?:else|try|(?:swi|ca)tch(?:\s+[$A-Za-z_\x7f-\uffff][$\w\x7f-\uffff]*)?|finally))\s*$|^\s*(else\b\s*)?(?:if|for|while|loop)\b(?!.*\bthen\b)/,e=/^(\s*)#/,g=/^\s*###(?!#)/,h=/^\s*/;this.getNextLineIndent=function(b,a,f){var e=this.$getIndent(a),d=this.getTokenizer().getLineTokens(a,b).tokens;!(d.length&&"comment"===d[d.length-1].type)&&("start"===b&&c.test(a))&&(e+=f);return e};this.toggleCommentLines=function(b,a,f,c){console.log("toggle");for(b=new k(0,0,0,
0);f<=c;++f){var d=a.getLine(f);g.test(d)||(d=e.test(d)?d.replace(e,"$1"):d.replace(h,"$&#"),b.end.row=b.start.row=f,b.end.column=d.length+1,a.replace(b,d))}};this.checkOutdent=function(b,a,f){return this.$outdent.checkOutdent(a,f)};this.autoOutdent=function(b,a,f){this.$outdent.autoOutdent(a,f)};this.createWorker=function(b){var a=new m(["ace"],"ace/mode/coffee_worker","Worker");a.attachToDocument(b.getDocument());a.on("error",function(a){b.setAnnotations([a.data])});a.on("ok",function(){b.clearAnnotations()});
return a};this.$id="ace/mode/coffee"}).call(e.prototype);g.Mode=e});