/**
 * Copyright (c) 2009-2013 Jeremy Ashkenas
 * 
 * Permission is hereby granted, free of charge, to any person
 * obtaining a copy of this software and associated documentation
 * files (the "Software"), to deal in the Software without
 * restriction, including without limitation the rights to use,
 * copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the
 * Software is furnished to do so, subject to the following
 * conditions:
 * 
 * The above copyright notice and this permission notice shall be
 * included in all copies or substantial portions of the Software.
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
 * OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
 * HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
 * WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
 * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
 * OTHER DEALINGS IN THE SOFTWARE.
 * 
 */

define(["require","exports","module","./helpers"],function(h,i){h("./helpers");var c=function(a,b,d){this.parent=a;this.expressions=b;this.method=d;this.variables=[{name:"arguments",type:"arguments"}];this.positions={};this.parent||(c.root=this)};c.root=null;c.prototype.add=function(a,b,d){return this.shared&&!d?this.parent.add(a,b,d):Object.prototype.hasOwnProperty.call(this.positions,a)?this.variables[this.positions[a]].type=b:this.positions[a]=this.variables.push({name:a,type:b})-1};c.prototype.namedMethod=
function(){var a;return null!=(a=this.method)&&a.name||!this.parent?this.method:this.parent.namedMethod()};c.prototype.find=function(a){if(this.check(a))return!0;this.add(a,"var");return!1};c.prototype.parameter=function(a){if(!this.shared||!this.parent.check(a,!0))return this.add(a,"param")};c.prototype.check=function(a){var b;return!!(this.type(a)||null!=(b=this.parent)&&b.check(a))};c.prototype.temporary=function(a,b){return 1<a.length?"_"+a+(1<b?b-1:""):"_"+(b+parseInt(a,36)).toString(36).replace(/\d/g,
"a")};c.prototype.type=function(a){var b,d,c,e;e=this.variables;d=0;for(c=e.length;d<c;d++)if(b=e[d],b.name===a)return b.type;return null};c.prototype.freeVariable=function(a,b){var d,c;null==b&&(b=!0);for(d=0;this.check(c=this.temporary(a,d));)d++;b&&this.add(c,"var",!0);return c};c.prototype.assign=function(a,b){this.add(a,{value:b,assigned:!0},!0);return this.hasAssignments=!0};c.prototype.hasDeclarations=function(){return!!this.declaredVariables().length};c.prototype.declaredVariables=function(){var a,
b,c,f,e,g;a=[];b=[];g=this.variables;f=0;for(e=g.length;f<e;f++)c=g[f],"var"===c.type&&("_"===c.name.charAt(0)?b:a).push(c.name);return a.sort().concat(b.sort())};c.prototype.assignedVariables=function(){var a,b,c,f,e;f=this.variables;e=[];b=0;for(c=f.length;b<c;b++)a=f[b],a.type.assigned&&e.push(""+a.name+" = "+a.type.value);return e};i.Scope=c});