/* ***** BEGIN LICENSE BLOCK *****
 * Distributed under the BSD license:
 *
 * Copyright (c) 2010, Ajax.org B.V.
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of Ajax.org B.V. nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL AJAX.ORG B.V. BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * ***** END LICENSE BLOCK ***** */

define("require exports module ../lib/oop ./text ./lua_highlight_rules ./folding/lua ../range ../worker/worker_client".split(" "),function(f,g){var h=f("../lib/oop"),i=f("./text").Mode,j=f("./lua_highlight_rules").LuaHighlightRules,k=f("./folding/lua").FoldMode,l=f("../range").Range,m=f("../worker/worker_client").WorkerClient,e=function(){this.HighlightRules=j;this.foldingRules=new k};h.inherits(e,i);(function(){function f(b){for(var a=0,c=0;c<b.length;c++){var d=b[c];"keyword"==d.type?d.value in
e&&(a+=e[d.value]):"paren.lparen"==d.type?a++:"paren.rparen"==d.type&&a--}return 0>a?-1:0<a?1:0}this.lineCommentStart="--";this.blockComment={start:"--[",end:"]--"};var e={"function":1,then:1,"do":1,"else":1,elseif:1,repeat:1,end:-1,until:-1},g=["else","elseif","end","until"];this.getNextLineIndent=function(b,a,c){var d=this.$getIndent(a),e=0,g=this.getTokenizer().getLineTokens(a,b).tokens;"start"==b&&(e=f(g));return 0<e?d+c:0>e&&d.substr(d.length-c.length)==c&&!this.checkOutdent(b,a,"\n")?d.substr(0,
d.length-c.length):d};this.checkOutdent=function(b,a,c){if("\n"!=c&&"\r"!=c&&"\r\n"!=c)return!1;if(a.match(/^\s*[\)\}\]]$/))return!0;b=this.getTokenizer().getLineTokens(a.trim(),b).tokens;return!b||!b.length?!1:"keyword"==b[0].type&&-1!=g.indexOf(b[0].value)};this.autoOutdent=function(b,a,c){var d=a.getLine(c-1),b=this.$getIndent(d).length,d=this.getTokenizer().getLineTokens(d,"start").tokens,e=a.getTabString().length,b=b+e*f(d);this.$getIndent(a.getLine(c)).length<b||a.outdentRows(new l(c,0,c+2,
0))};this.createWorker=function(b){var a=new m(["ace"],"ace/mode/lua_worker","Worker");a.attachToDocument(b.getDocument());a.on("error",function(a){b.setAnnotations([a.data])});a.on("ok",function(){b.clearAnnotations()});return a};this.$id="ace/mode/lua"}).call(e.prototype);g.Mode=e});