/* ***** BEGIN LICENSE BLOCK *****
 * Distributed under the BSD license:
 *
 * Copyright (c) 2010, Ajax.org B.V.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of Ajax.org B.V. nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL AJAX.ORG B.V. BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * ***** END LICENSE BLOCK ***** */

define("require exports module ../lib/oop ./text ./php_highlight_rules ./php_highlight_rules ./matching_brace_outdent ../range ../worker/worker_client ./behaviour/cstyle ./folding/cstyle ../unicode ./html ./javascript ./css".split(" "),function(b,j){var g=b("../lib/oop"),c=b("./text").Mode,k=b("./php_highlight_rules").PhpHighlightRules,l=b("./php_highlight_rules").PhpLangHighlightRules,m=b("./matching_brace_outdent").MatchingBraceOutdent;b("../range");var n=b("../worker/worker_client").WorkerClient,
o=b("./behaviour/cstyle").CstyleBehaviour,h=b("./folding/cstyle").FoldMode,a=b("../unicode"),i=b("./html").Mode,p=b("./javascript").Mode,q=b("./css").Mode,d=function(){this.HighlightRules=l;this.$outdent=new m;this.$behaviour=new o;this.foldingRules=new h};g.inherits(d,c);(function(){this.tokenRe=RegExp("^["+a.packages.L+a.packages.Mn+a.packages.Mc+a.packages.Nd+a.packages.Pc+"_]+","g");this.nonTokenRe=RegExp("^(?:[^"+a.packages.L+a.packages.Mn+a.packages.Mc+a.packages.Nd+a.packages.Pc+"_]|s])+",
"g");this.lineCommentStart=["//","#"];this.blockComment={start:"/*",end:"*/"};this.getNextLineIndent=function(e,f,b){var a=this.$getIndent(f),c=this.getTokenizer().getLineTokens(f,e),d=c.tokens,c=c.state;if(d.length&&"comment"==d[d.length-1].type)return a;if("start"==e)(e=f.match(/^.*[\{\(\[\:]\s*$/))&&(a+=b);else if("doc-start"==e){if("doc-start"!=c)return"";if(e=f.match(/^\s*(\/?)\*/))e[1]&&(a+=" "),a+="* "}return a};this.checkOutdent=function(a,b,c){return this.$outdent.checkOutdent(b,c)};this.autoOutdent=
function(a,b,c){this.$outdent.autoOutdent(b,c)};this.$id="ace/mode/php-inline"}).call(d.prototype);c=function(a){if(a&&a.inline)return a=new d,a.createWorker=this.createWorker,a.inlinePhp=!0,a;i.call(this);this.HighlightRules=k;this.createModeDelegates({"js-":p,"css-":q,"php-":d});this.foldingRules.subModes["php-"]=new h};g.inherits(c,i);(function(){this.createWorker=function(a){var b=new n(["ace"],"ace/mode/php_worker","PhpWorker");b.attachToDocument(a.getDocument());this.inlinePhp&&b.call("setOptions",
[{inline:!0}]);b.on("error",function(b){a.setAnnotations(b.data)});b.on("ok",function(){a.clearAnnotations()});return b};this.$id="ace/mode/php"}).call(c.prototype);j.Mode=c});