/* ***** BEGIN LICENSE BLOCK *****
 * Distributed under the BSD license:
 *
 * Copyright (c) 2010, Ajax.org B.V.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of Ajax.org B.V. nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL AJAX.ORG B.V. BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * ***** END LICENSE BLOCK ***** */

define("require exports module ../lib/oop ./javascript_highlight_rules ./text_highlight_rules".split(" "),function(a,h){var i=a("../lib/oop"),j=a("./javascript_highlight_rules").JavaScriptHighlightRules,k=a("./text_highlight_rules").TextHighlightRules,g=function(){var b=function(d){var b=d.token,a=d.regex,c=function(b,a){0===a.length&&a.unshift(b);a.unshift(d.next);return d.next};c.isContextAware=!0;return{token:b,regex:a,next:c}},c=function(a){var b=a.token,a=a.regex,c=function(a,b){b.shift();return b[0]||
"start"};c.isContextAware=!0;return{token:b,regex:a,next:c}};this.$rules=(new j({noES6:!0})).$rules;this.$rules.no_regex=[{token:"keyword",regex:"(waitfor|or|and|collapse|spawn|retract)\\b"},{token:"keyword.operator",regex:"(->|=>|\\.\\.)"},{token:"variable.language",regex:"(hold|default)\\b"},b({token:"string",regex:"`",next:"bstring"}),b({token:"string",regex:'"',next:"qqstring"}),b({token:"string",regex:'"',next:"qqstring"}),{token:["paren.lparen","text","paren.rparen"],regex:"(\\{)(\\s*)(\\|)",
next:"block_arguments"}].concat(this.$rules.no_regex);this.$rules.block_arguments=[{token:"paren.rparen",regex:"\\|",next:"no_regex"}].concat(this.$rules.function_arguments);this.$rules.bstring=[{token:"constant.language.escape",regex:"\\\\(?:x[0-9a-fA-F]{2}|u[0-9a-fA-F]{4}|[0-2][0-7]{0,2}|3[0-6][0-7]?|37[0-7]?|[4-7][0-7]?|.)"},{token:"string",regex:"\\\\$",next:"bstring"},b({token:"paren.lparen",regex:"\\$\\{",next:"string_interp"}),b({token:"paren.lparen",regex:"\\$",next:"bstring_interp_single"}),
c({token:"string",regex:"`"}),{defaultToken:"string"}];this.$rules.qqstring=[{token:"constant.language.escape",regex:"\\\\(?:x[0-9a-fA-F]{2}|u[0-9a-fA-F]{4}|[0-2][0-7]{0,2}|3[0-6][0-7]?|37[0-7]?|[4-7][0-7]?|.)"},{token:"string",regex:"\\\\$",next:"qqstring"},b({token:"paren.lparen",regex:"#\\{",next:"string_interp"}),c({token:"string",regex:'"'}),{defaultToken:"string"}];for(var a=[],f=0;f<this.$rules.no_regex.length;f++){var e=this.$rules.no_regex[f];-1==String(e.token).indexOf("paren")&&(!e.next||
e.next.isContextAware)&&a.push(e)}this.$rules.string_interp=[c({token:"paren.rparen",regex:"\\}"}),b({token:"paren.lparen",regex:"{",next:"string_interp"})].concat(a);this.$rules.bstring_interp_single=[{token:["identifier","paren.lparen"],regex:"(\\w+)(\\()",next:"bstring_interp_single_call"},c({token:"identifier",regex:"\\w*"})];this.$rules.bstring_interp_single_call=[b({token:"paren.lparen",regex:"\\(",next:"bstring_interp_single_call"}),c({token:"paren.rparen",regex:"\\)"})].concat(a)};i.inherits(g,
k);h.SJSHighlightRules=g});