/**
* WebViewer3D provides an HTML5-based 3D viewing component
* 
* @module WebViewer3D
* @author DOGO, PHST
* @copyright	2014 Esko Stonecube Ltd. All rights reserved.
*/

define(["WV3Dmod/ViewerController","WV3Dmod/Constants"],function(g){var a=function(d,a,b){console.log("Creating WebViewer3DAPI Object");this._controller=new g(d,a,b)};a.prototype.Initialize=function(){console.log("Initialize: Deprecated API function !!!!!!!!!!!!!!!! (No need to call that function anymore)")};a.prototype.Resize=function(){this._controller.get("_view").Resize()};a.prototype.LoadScene=function(d,a,b,c){console.log("API Load Scene from URL");this._controller.LoadSceneFromURL(d,a,b,c)};
a.prototype.LoadSceneFromLocalFile=function(d,a,b,c){console.log("API Load Scene from local file");var f=new FileReader,h=this;f.onload=function(){h.LoadSceneFromObject(JSON.parse(f.result),a,b,c)};f.readAsText(d)};a.prototype.LoadSceneFromObject=function(d,a,b,c){console.log("API Load Scene from object");this._controller.LoadSceneFromJSONObject(d,a,b,c)};a.prototype.ResetMainSceneVisibility=function(){console.log("API Reset visiblity of main scene: ");this._controller.ResetMainSceneVisibility()};
a.prototype.ToggleNodeVisibility=function(d,a,b){this._controller.ToggleNodeVisibility(d,a,b)};a.prototype.SetNodeVisibility=function(d,a,b,c){this._controller.SetNodeVisibility(d,a,b,c)};a.prototype.SetCameraAngles=function(a,e){this._controller.SetCameraAngles(a,e)};a.prototype.ResetCamera=function(){this._controller.ResetCamera()};a.prototype.ToggleInteractiveCameraControl=function(a){this._controller.SetInteractiveCameraControl(a)};a.prototype.SetCameraScale=function(a){this._controller.SetCameraScale(a)};
a.prototype.SetPerspectiveCamera=function(a){this._controller.SetPerspectiveCamera(a)};a.prototype.SetOrthographicCamera=function(){this._controller.SetOrthographicCamera()};a.prototype.SetHighlights=function(a){this._controller.SetHighlights(a)};a.prototype.SetLabelsVisibility=function(a,e,b,c){this._controller.SetLabelsVisibility(a,e,b,c)};a.prototype.SetLabelText=function(a,e,b){this._controller.SetLabelText(a,e,b)};a.prototype.SetLabelsParameters=function(a){this._controller.SetLabelsParameters(JSON.parse(a))};
a.prototype.SetDimensionsVisibility=function(a,e,b,c,f,h,g,i,j){this._controller.SetDimensionsVisibility(a,e,parseFloat(b),c,parseFloat(f),h,parseFloat(g),i,j,!0)};a.prototype.SetDimensionsParameters=function(a){this._controller.SetDimensionsParameters(JSON.parse(a))};a.prototype.SetBackgroundColor=function(a,e,b,c){this._controller.SetBackgroundColor(parseFloat(a),parseFloat(e),parseFloat(b),parseFloat(c))};a.prototype.SetHighlightsColor=function(a,e,b){this._controller.SetHighlightsColor(parseFloat(a),
parseFloat(e),parseFloat(b))};a.prototype.GetSystemSupportLevel=function(){return this._controller.GetSystemSupportLevel()};a.prototype.GetSystemReport=function(){return this._controller.GetSystemReport()};a.prototype.GetSnapshot=function(a){return this._controller.GetSnapshot(a)};return a});