/* ***** BEGIN LICENSE BLOCK *****
 * Distributed under the BSD license:
 *
 * Copyright (c) 2010, Ajax.org B.V.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of Ajax.org B.V. nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL AJAX.ORG B.V. BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * ***** END LICENSE BLOCK ***** */

define("require exports module ../edit_session ../layer/text ../requirejs/text!./static.css ../config ../lib/dom".split(" "),function(f,r,l){var m=f("../edit_session").EditSession,p=f("../layer/text").Text,q=f("../requirejs/text!./static.css"),n=f("../config"),o=f("../lib/dom"),k=function(e,a,h){var b=e.className.match(/lang-(\w+)/),b=a.mode||b&&"ace/mode/"+b[1];if(!b)return!1;var f=a.theme||"ace/theme/textmate",d="",i=[];if(e.firstElementChild)for(var c=0,j=0;j<e.childNodes.length;j++){var g=e.childNodes[j];
3==g.nodeType?(c+=g.data.length,d+=g.data):i.push(c,g)}else d=o.getInnerText(e),a.trim&&(d=d.trim());k.render(d,b,f,a.firstLineNumber,!a.showGutter,function(a){o.importCssString(a.css,"ace_highlight");e.innerHTML=a.html;for(var d=e.firstChild.firstChild,b=0;b<i.length;b+=2){var c=a.session.doc.indexToPosition(i[b]),g=i[b+1];(c=d.children[c.row])&&c.appendChild(g)}h&&h()})};k.render=function(e,a,h,b,f,d){function i(){var c=k.renderSync(e,a,h,b,f);return d?d(c):c}var c=1,j=m.prototype.$modes;"string"==
typeof h&&(c++,n.loadModule(["theme",h],function(a){h=a;--c||i()}));var g;a&&("object"===typeof a&&!a.getTokenizer)&&(g=a,a=g.path);"string"==typeof a&&(c++,n.loadModule(["mode",a],function(b){if(!j[a]||g)j[a]=new b.Mode(g);a=j[a];--c||i()}));return--c||i()};k.renderSync=function(e,a,h,b,f){var b=parseInt(b||1,10),d=new m("");d.setUseWorker(!1);d.setMode(a);a=new p(document.createElement("div"));a.setSession(d);a.config={characterWidth:10,lineHeight:20};d.setValue(e);for(var e=[],i=d.getLength(),
c=0;c<i;c++)e.push("<div class='ace_line'>"),f||e.push("<span class='ace_gutter ace_gutter-cell' unselectable='on'></span>"),a.$renderLine(e,c,!0,!1),e.push("\n</div>");b="<div class='"+h.cssClass+"'><div class='ace_static_highlight' style='counter-reset:ace_line "+(b-1)+"'>"+e.join("")+"</div></div>";a.destroy();return{css:q+h.cssText,html:b,session:d}};l.exports=k;l.exports.highlight=k});