/* ***** BEGIN LICENSE BLOCK *****
 * Distributed under the BSD license:
 *
 * Copyright (c) 2010, Ajax.org B.V.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of Ajax.org B.V. nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL AJAX.ORG B.V. BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * ***** END LICENSE BLOCK ***** */

define("require exports module ../lib/event ../lib/useragent ../lib/dom ../lib/lang".split(" "),function(j,B){var d=j("../lib/event"),g=j("../lib/useragent"),C=j("../lib/dom"),p=j("../lib/lang"),L=18>g.isChrome,M=g.isIE;B.TextInput=function(j,b){function i(a){if(!e){e=!0;if(k)b=0,a=a?0:c.value.length-1;else var b=a?2:1,a=2;try{c.setSelectionRange(b,a)}catch(f){}e=!1}}function l(){e||(c.value=h,g.isWebKit&&N.schedule())}function u(){clearTimeout(D);D=setTimeout(function(){n&&(c.style.cssText=n,n="");
null==b.renderer.$keepTextAreaAtCursor&&(b.renderer.$keepTextAreaAtCursor=!0,b.renderer.$moveTextAreaToCursor())},g.isOldIE?200:0)}var c=C.createElement("textarea");c.className="ace_text-input";g.isTouchPad&&c.setAttribute("x-palm-disable-auto-cap",!0);c.setAttribute("wrap","off");c.setAttribute("autocorrect","off");c.setAttribute("autocapitalize","off");c.setAttribute("spellcheck",!1);c.style.opacity="0";g.isOldIE&&(c.style.top="-100px");j.insertBefore(c,j.firstChild);var h="\u0001\u0001",q=!1,v=
!1,e=!1,n="",r=!0;try{var m=document.activeElement===c}catch(B){}d.addListener(c,"blur",function(a){b.onBlur(a);m=!1});d.addListener(c,"focus",function(a){m=!0;b.onFocus(a);i()});this.focus=function(){c.style.position="fixed";c.style.top="-10000000px";c.focus();setTimeout(function(){c.style.position=""},0)};this.blur=function(){c.blur()};this.isFocused=function(){return m};var O=p.delayedCall(function(){m&&i(r)}),N=p.delayedCall(function(){e||(c.value=h,m&&i())});g.isWebKit||b.addEventListener("changeSelection",
function(){b.selection.isEmpty()!=r&&(r=!r,O.schedule())});l();if(m)b.onFocus();var E=function(a){return 0===a.selectionStart&&a.selectionEnd===a.value.length};!c.setSelectionRange&&c.createTextRange&&(c.setSelectionRange=function(a,c){var b=this.createTextRange();b.collapse(!0);b.moveStart("character",a);b.moveEnd("character",c);b.select()},E=function(a){try{var b=a.ownerDocument.selection.createRange()}catch(c){}return!b||b.parentElement()!=a?!1:b.text==a.value});if(g.isOldIE){var w=!1,o=function(a){if(!w){var b=
c.value;if(!e&&b&&b!=h){if(a&&b==h[0])return x.schedule();y(b);w=!0;l();w=!1}}},x=p.delayedCall(o);d.addListener(c,"propertychange",o);var P={13:1,27:1};d.addListener(c,"keyup",function(a){e&&(!c.value||P[a.keyCode])&&setTimeout(s,0);if(129>(c.value.charCodeAt(0)||0))return x.call();e?z():F()});d.addListener(c,"keydown",function(){x.schedule(50)})}var k=null;this.setInputHandler=function(a){k=a};this.getInputHandler=function(){return k};var t=!1,y=function(a){k&&(a=k(a),k=null);if(v){i();if(a)b.onPaste(a);
v=!1}else if(a==h.charAt(0))t?b.execCommand("del",{source:"ace"}):b.execCommand("backspace",{source:"ace"});else if(a.substring(0,2)==h?a=a.substr(2):a.charAt(0)==h.charAt(0)?a=a.substr(1):a.charAt(a.length-1)==h.charAt(0)&&(a=a.slice(0,-1)),a.charAt(a.length-1)==h.charAt(0)&&(a=a.slice(0,-1)),a)b.onTextInput(a);t&&(t=!1)},G=function(a,b){var c=a.clipboardData||window.clipboardData;if(c&&!L){var d=M?"Text":"text/plain";return b?!1!==c.setData(d,b):c.getData(d)}},H=function(a,e){var f=b.getCopyText();
if(!f)return d.preventDefault(a);G(a,f)?(e?b.onCut():b.onCopy(),d.preventDefault(a)):(q=!0,c.value=f,c.select(),setTimeout(function(){q=!1;l();i();e?b.onCut():b.onCopy()}))},I=function(a){H(a,!0)},J=function(a){H(a,!1)},K=function(a){var e=G(a);if("string"==typeof e){if(e)b.onPaste(e);g.isIE&&setTimeout(i);d.preventDefault(a)}else c.value="",v=!0};d.addCommandKeyListener(c,b.onCommandKey.bind(b));d.addListener(c,"select",function(){q?q=!1:E(c)?(b.selectAll(),i()):k&&i(b.selection.isEmpty())});d.addListener(c,
"input",function(){e||(y(c.value),l())});d.addListener(c,"cut",I);d.addListener(c,"copy",J);d.addListener(c,"paste",K);(!("oncut"in c)||!("oncopy"in c)||!("onpaste"in c))&&d.addListener(j,"keydown",function(a){if((!g.isMac||a.metaKey)&&a.ctrlKey)switch(a.keyCode){case 67:J(a);break;case 86:K(a);break;case 88:I(a)}});var F=function(){!e&&(b.onCompositionStart&&!b.$readOnly)&&(e={},b.onCompositionStart(),setTimeout(z,0),b.on("mousedown",s),b.selection.isEmpty()||(b.insert(""),b.session.markUndoGroup(),
b.selection.clearSelection()),b.session.markUndoGroup())},z=function(){if(e&&b.onCompositionUpdate&&!b.$readOnly){var a=c.value.replace(/\x01/g,"");e.lastValue!==a&&(b.onCompositionUpdate(a),e.lastValue&&b.undo(),e.lastValue=a,e.lastValue&&(a=b.selection.getRange(),b.insert(e.lastValue),b.session.markUndoGroup(),e.range=b.selection.getRange(),b.selection.setRange(a),b.selection.clearSelection()))}},s=function(a){if(b.onCompositionEnd&&!b.$readOnly){var d=e;e=!1;var f=setTimeout(function(){f=null;
var a=c.value.replace(/\x01/g,"");e||(a==d.lastValue?l():!d.lastValue&&a&&(l(),y(a)))});k=function(a){f&&clearTimeout(f);a=a.replace(/\x01/g,"");if(a==d.lastValue)return"";d.lastValue&&f&&b.undo();return a};b.onCompositionEnd();b.removeListener("mousedown",s);"compositionend"==a.type&&d.range&&b.selection.setRange(d.range)}},A=p.delayedCall(z,50);d.addListener(c,"compositionstart",F);g.isGecko?d.addListener(c,"text",function(){A.schedule()}):(d.addListener(c,"keyup",function(){A.schedule()}),d.addListener(c,
"keydown",function(){A.schedule()}));d.addListener(c,"compositionend",s);this.getElement=function(){return c};this.setReadOnly=function(a){c.readOnly=a};this.onContextMenu=function(a){t=!0;i(b.selection.isEmpty());b._emit("nativecontextmenu",{target:b,domEvent:a});this.moveToMouse(a,!0)};this.moveToMouse=function(a,e){if(e||!g.isOldIE){n||(n=c.style.cssText);c.style.cssText=(e?"z-index:100000;":"")+"height:"+c.style.height+";"+(g.isIE?"opacity:0.1;":"");var f=b.container.getBoundingClientRect(),i=
C.computedStyle(b.container),h=f.top+(parseInt(i.borderTopWidth)||0),j=f.left+(parseInt(f.borderLeftWidth)||0),k=f.bottom-h-c.clientHeight-2,f=function(a){c.style.left=a.clientX-j-2+"px";c.style.top=Math.min(a.clientY-h-2,k)+"px"};f(a);"mousedown"==a.type&&(b.renderer.$keepTextAreaAtCursor&&(b.renderer.$keepTextAreaAtCursor=null),g.isWin&&!g.isOldIE&&d.capture(b.container,f,u))}};this.onContextMenuClose=u;var D,o=function(a){b.textInput.onContextMenu(a);u()};d.addListener(b.renderer.scroller,"contextmenu",
o);d.addListener(c,"contextmenu",o)}});