/* ***** BEGIN LICENSE BLOCK *****
 * Distributed under the BSD license:
 *
 * Copyright (c) 2010, Ajax.org B.V.
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of Ajax.org B.V. nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL AJAX.ORG B.V. BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * ***** END LICENSE BLOCK ***** */

define("require exports module ../lib/oop ./text ./c_cpp_highlight_rules ./matching_brace_outdent ../range ./behaviour/cstyle ./folding/cstyle".split(" "),function(a,g){var h=a("../lib/oop"),i=a("./text").Mode,j=a("./c_cpp_highlight_rules").c_cppHighlightRules,k=a("./matching_brace_outdent").MatchingBraceOutdent;a("../range");var l=a("./behaviour/cstyle").CstyleBehaviour,m=a("./folding/cstyle").FoldMode,b=function(){this.HighlightRules=j;this.$outdent=new k;this.$behaviour=new l;this.foldingRules=
new m};h.inherits(b,i);(function(){this.lineCommentStart="//";this.blockComment={start:"/*",end:"*/"};this.getNextLineIndent=function(d,e,a){var c=this.$getIndent(e),f=this.getTokenizer().getLineTokens(e,d),b=f.tokens,f=f.state;if(b.length&&"comment"==b[b.length-1].type)return c;if("start"==d)(d=e.match(/^.*[\{\(\[]\s*$/))&&(c+=a);else if("doc-start"==d){if("start"==f)return"";if(d=e.match(/^\s*(\/?)\*/))d[1]&&(c+=" "),c+="* "}return c};this.checkOutdent=function(a,e,b){return this.$outdent.checkOutdent(e,
b)};this.autoOutdent=function(a,b,g){this.$outdent.autoOutdent(b,g)};this.$id="ace/mode/c_cpp"}).call(b.prototype);g.Mode=b});