/* ***** BEGIN LICENSE BLOCK *****
 * Distributed under the BSD license:
 *
 * Copyright (c) 2010, Ajax.org B.V.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of Ajax.org B.V. nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL AJAX.ORG B.V. BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * ***** END LICENSE BLOCK ***** */

define("require exports module ../../lib/oop ./fold_mode ../../range".split(" "),function(f,j){var k=f("../../lib/oop"),n=f("./fold_mode").FoldMode,l=f("../../range").Range,i=j.FoldMode=function(){};k.inherits(i,n);(function(){this.foldingStartMarker=/^(?:\|={10,}|[\.\/=\-~^+]{4,}\s*$|={1,5} )/;this.singleLineHeadingRe=/^={1,5}(?=\s+\S)/;this.getFoldWidget=function(c,d,a){d=c.getLine(a);return!this.foldingStartMarker.test(d)?"":"="==d[0]?this.singleLineHeadingRe.test(d)?"start":c.getLine(a-1).length!=
c.getLine(a).length?"":"start":"dissallowDelimitedBlock"==c.bgTokenizer.getState(a)?"end":"start"};this.getFoldWidgetRange=function(c,d,a){function f(a){return(g=c.getTokens(a)[0])&&g.type}function i(){var b=g.value.match(k);if(b)return b[0].length;b=j.indexOf(g.value[0])+1;return 1==b&&c.getLine(a-1).length!=c.getLine(a).length?Infinity:b}var m=c.getLine(a),d=m.length,h=c.getLength(),e=a,b=a;if(m.match(this.foldingStartMarker)){var g,j=["=","-","~","^","+"],k=this.singleLineHeadingRe;if("markup.heading"==
f(a)){for(b=i();++a<h&&!("markup.heading"==f(a)&&i()<=b););b=g&&g.value.match(this.singleLineHeadingRe)?a-1:a-2;if(b>e)for(;b>e&&(!f(b)||"["==g.value[0]);)b--;if(b>e)return h=c.getLine(b).length,new l(e,d,b,h)}else if("dissallowDelimitedBlock"==c.bgTokenizer.getState(a)){for(;0<a--&&-1!=c.bgTokenizer.getState(a).lastIndexOf("Block"););b=a+1;if(b<e)return h=c.getLine(a).length,new l(b,5,e,d-5)}else{for(;++a<h&&"dissallowDelimitedBlock"!=c.bgTokenizer.getState(a););b=a;if(b>e)return h=c.getLine(a).length,
new l(e,5,b,h-5)}}}}).call(i.prototype)});