/* ***** BEGIN LICENSE BLOCK *****
 * Distributed under the BSD license:
 *
 * Copyright (c) 2012, Ajax.org B.V.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of Ajax.org B.V. nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL AJAX.ORG B.V. BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * ***** END LICENSE BLOCK ***** */

define("require exports module ../../lib/oop ./fold_mode ../../range ../../token_iterator".split(" "),function(i,m){var n=i("../../lib/oop"),o=i("./fold_mode").FoldMode,k=i("../../range").Range,l=i("../../token_iterator").TokenIterator,j=m.FoldMode=function(){};n.inherits(j,o);(function(){this.foldingStartMarker=/^\s*\\(begin)|(section|subsection|paragraph)\b|{\s*$/;this.foldingStopMarker=/^\s*\\(end)\b|^\s*}/;this.getFoldWidgetRange=function(e,b,c){var b=e.doc.getLine(c),d=this.foldingStartMarker.exec(b);
if(d)return d[1]?this.latexBlock(e,c,d[0].length-1):d[2]?this.latexSection(e,c,d[0].length-1):this.openingBracketBlock(e,"{",c,d.index);if(d=this.foldingStopMarker.exec(b))return d[1]?this.latexBlock(e,c,d[0].length-1):this.closingBracketBlock(e,"}",c,d.index+d[0].length)};this.latexBlock=function(e,b,c){var d={"\\begin":1,"\\end":-1},a=new l(e,b,c),f=a.getCurrentToken();if(f&&("storage.type"==f.type||"constant.character.escape"==f.type)){var h=d[f.value],c=function(){var b="lparen"==a.stepForward().type?
a.stepForward().value:"";-1===h&&(a.stepBackward(),b&&a.stepBackward());return b},g=[c()],i=-1===h?a.getCurrentTokenColumn():e.getLine(b).length,j=b;for(a.step=-1===h?a.stepBackward:a.stepForward;f=a.step();)if(f&&("storage.type"==f.type||"constant.character.escape"==f.type))if(b=d[f.value])if(f=c(),b===h)g.unshift(f);else if(g.shift()!==f||!g.length)break;if(!g.length){b=a.getCurrentTokenRow();if(-1===h)return new k(b,e.getLine(b).length,j,i);a.stepBackward();return new k(j,i,b,a.getCurrentTokenColumn())}}};
this.latexSection=function(e,b,c){var d=["\\subsection","\\section","\\begin","\\end","\\paragraph"],c=new l(e,b,c),a=c.getCurrentToken();if(a&&"storage.type"==a.type){for(var f=d.indexOf(a.value),h=0,g=b;a=c.stepForward();)if("storage.type"===a.type)if(a=d.indexOf(a.value),2<=a){if(h||(g=c.getCurrentTokenRow()-1),h+=2==a?1:-1,0>h)break}else if(a>=f)break;for(h||(g=c.getCurrentTokenRow()-1);g>b&&!/\S/.test(e.getLine(g));)g--;return new k(b,e.getLine(b).length,g,e.getLine(g).length)}}}).call(j.prototype)});