/* ***** BEGIN LICENSE BLOCK *****
 * Distributed under the BSD license:
 *
 * Copyright (c) 2010, Ajax.org B.V.
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of Ajax.org B.V. nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL AJAX.ORG B.V. BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * ***** END LICENSE BLOCK ***** */

"undefined"!==typeof process&&require("amd-loader");
define("require exports module ../xml ../../edit_session ../../test/assertions".split(" "),function(d,h,g){var e=d("../xml").Mode,f=d("../../edit_session").EditSession,b=d("../../test/assertions");g.exports={"test: fold multi line self closing element":function(){var a=new f(["<person",'  firstname="fabian"','  lastname="jakobs"/>']),c=new e;a.setFoldStyle("markbeginend");a.setMode(c);b.equal(a.getFoldWidget(0),"start");b.equal(a.getFoldWidget(1),"");b.equal(a.getFoldWidget(2),"end");b.range(a.getFoldWidgetRange(0),
0,8,2,19);b.range(a.getFoldWidgetRange(2),0,8,2,19)},"test: fold should skip self closing elements":function(){var a=new f(["<person>",'  <attrib value="fabian"/>',"</person>"]),c=new e;a.setFoldStyle("markbeginend");a.setMode(c);b.equal(a.getFoldWidget(0),"start");b.equal(a.getFoldWidget(1),"");b.equal(a.getFoldWidget(2),"end");b.range(a.getFoldWidgetRange(0),0,8,2,0);b.range(a.getFoldWidgetRange(2),0,8,2,0)},"test: fold should skip multi line self closing elements":function(){var a=new f(["<person>",
"  <attib",'     key="name"','     value="fabian"/>',"</person>"]),c=new e;a.setMode(c);a.setFoldStyle("markbeginend");b.equal(a.getFoldWidget(0),"start");b.equal(a.getFoldWidget(1),"start");b.equal(a.getFoldWidget(2),"");b.equal(a.getFoldWidget(3),"end");b.equal(a.getFoldWidget(4),"end");b.range(a.getFoldWidgetRange(0),0,8,4,0);b.range(a.getFoldWidgetRange(1),1,9,3,19);b.range(a.getFoldWidgetRange(3),1,9,3,19);b.range(a.getFoldWidgetRange(4),0,8,4,0)}}});
"undefined"!==typeof module&&module===require.main&&require("asyncjs").test.testcase(module.exports).exec();