/* ***** BEGIN LICENSE BLOCK *****
 * Distributed under the BSD license:
 *
 * Copyright (c) 2010, Ajax.org B.V.
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of Ajax.org B.V. nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL AJAX.ORG B.V. BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * ***** END LICENSE BLOCK ***** */

define("require exports module ../lib/oop ../lib/lang ./text ./javascript ./css ./html_highlight_rules ./behaviour/xml ./folding/html ./html_completions ../worker/worker_client".split(" "),function(a,e){var f=a("../lib/oop"),d=a("../lib/lang"),g=a("./text").Mode,h=a("./javascript").Mode,i=a("./css").Mode,j=a("./html_highlight_rules").HtmlHighlightRules,k=a("./behaviour/xml").XmlBehaviour,l=a("./folding/html").FoldMode,m=a("./html_completions").HtmlCompletions,n=a("../worker/worker_client").WorkerClient,
o="area base br col embed hr img input keygen link meta menuitem param source track wbr".split(" "),p="li dt dd p rt rp optgroup option colgroup td th".split(" "),c=function(a){this.fragmentContext=a&&a.fragmentContext;this.HighlightRules=j;this.$behaviour=new k;this.$completer=new m;this.createModeDelegates({"js-":h,"css-":i});this.foldingRules=new l(this.voidElements,d.arrayToMap(p))};f.inherits(c,g);(function(){this.blockComment={start:"<\!--",end:"--\>"};this.voidElements=d.arrayToMap(o);this.getNextLineIndent=
function(a,b){return this.$getIndent(b)};this.checkOutdent=function(){return!1};this.getCompletions=function(a,b,c,d){return this.$completer.getCompletions(a,b,c,d)};this.createWorker=function(a){if(this.constructor==c){var b=new n(["ace"],"ace/mode/html_worker","Worker");b.attachToDocument(a.getDocument());this.fragmentContext&&b.call("setOptions",[{context:this.fragmentContext}]);b.on("error",function(b){a.setAnnotations(b.data)});b.on("terminate",function(){a.clearAnnotations()});return b}};this.$id=
"ace/mode/html"}).call(c.prototype);e.Mode=c});