/* ***** BEGIN LICENSE BLOCK *****
 * Distributed under the BSD license:
 *
 * Copyright (c) 2010, Ajax.org B.V.
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of Ajax.org B.V. nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL AJAX.ORG B.V. BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * ***** END LICENSE BLOCK ***** */

define("require exports module ../lib/oop ./text ./python_highlight_rules ./folding/pythonic ../range".split(" "),function(a,g){var h=a("../lib/oop"),i=a("./text").Mode,j=a("./python_highlight_rules").PythonHighlightRules,k=a("./folding/pythonic").FoldMode,l=a("../range").Range,f=function(){this.HighlightRules=j;this.foldingRules=new k("\\:")};h.inherits(f,i);(function(){this.lineCommentStart="#";this.getNextLineIndent=function(c,b,e){var d=this.$getIndent(b),a=this.getTokenizer().getLineTokens(b,
c).tokens;if(a.length&&"comment"==a[a.length-1].type)return d;"start"==c&&b.match(/^.*[\{\(\[\:]\s*$/)&&(d+=e);return d};var a={pass:1,"return":1,raise:1,"break":1,"continue":1};this.checkOutdent=function(c,b,e){if("\r\n"!==e&&"\r"!==e&&"\n"!==e)return!1;c=this.getTokenizer().getLineTokens(b.trim(),c).tokens;if(!c)return!1;do b=c.pop();while(b&&("comment"==b.type||"text"==b.type&&b.value.match(/^\s+$/)));return!b?!1:"keyword"==b.type&&a[b.value]};this.autoOutdent=function(c,b,a){var a=a+1,c=this.$getIndent(b.getLine(a)),
d=b.getTabString();c.slice(-d.length)==d&&b.remove(new l(a,c.length-d.length,a,c.length))};this.$id="ace/mode/python"}).call(f.prototype);g.Mode=f});