/* ***** BEGIN LICENSE BLOCK *****
 * Distributed under the BSD license:
 *
 * Copyright (c) 2012, Ajax.org B.V.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of Ajax.org B.V. nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL AJAX.ORG B.V. BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * ***** END LICENSE BLOCK ***** */

define("require exports module ../lib/oop ./text ../tokenizer ./vala_highlight_rules ./folding/cstyle ./behaviour/cstyle ./folding/cstyle ./matching_brace_outdent".split(" "),function(a,g){var h=a("../lib/oop"),i=a("./text").Mode;a("../tokenizer");var j=a("./vala_highlight_rules").ValaHighlightRules;a("./folding/cstyle");var k=a("./behaviour/cstyle").CstyleBehaviour,l=a("./folding/cstyle").FoldMode,m=a("./matching_brace_outdent").MatchingBraceOutdent,b=function(){this.HighlightRules=j;this.$outdent=
new m;this.$behaviour=new k;this.foldingRules=new l};h.inherits(b,i);(function(){this.lineCommentStart="//";this.blockComment={start:"/*",end:"*/"};this.getNextLineIndent=function(d,a,e){var c=this.$getIndent(a),f=this.getTokenizer().getLineTokens(a,d),b=f.tokens,f=f.state;if(b.length&&"comment"==b[b.length-1].type)return c;if("start"==d||"no_regex"==d)(d=a.match(/^.*(?:\bcase\b.*\:|[\{\(\[])\s*$/))&&(c+=e);else if("doc-start"==d){if("start"==f||"no_regex"==f)return"";if(d=a.match(/^\s*(\/?)\*/))d[1]&&
(c+=" "),c+="* "}return c};this.checkOutdent=function(a,b,e){return this.$outdent.checkOutdent(b,e)};this.autoOutdent=function(a,b,e){this.$outdent.autoOutdent(b,e)};this.$id="ace/mode/vala"}).call(b.prototype);g.Mode=b});