/* ***** BEGIN LICENSE BLOCK *****
 * Distributed under the BSD license:
 *
 * Copyright (c) 2010, Ajax.org B.V.
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of Ajax.org B.V. nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL AJAX.ORG B.V. BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * ***** END LICENSE BLOCK ***** */

define(["require","exports","module","../lib/event","../lib/useragent"],function(l,p){function m(b,f){return b.row==f.row&&b.column==f.column}var z=l("../lib/event"),x=l("../lib/useragent");p.onMouseDown=function(b){var f=b.domEvent,i=f.altKey,n=f.shiftKey,q=f.ctrlKey,j=b.getAccelKey(),d=b.getButton();q&&x.isMac&&(d=f.button);if(b.editor.inMultiSelectMode&&2==d)b.editor.textInput.onContextMenu(b.domEvent);else if(!q&&!i&&!j)0===d&&b.editor.inMultiSelectMode&&b.editor.exitMultiSelectMode();else if(0===
d){var a=b.editor,c=a.selection,d=a.inMultiSelectMode,r=b.getDocumentPosition(),s=c.getCursor(),s=b.inSelection()||c.isEmpty()&&m(r,s),t=b.x,u=b.y,l=function(a){t=a.clientX;u=a.clientY},y=a.session,v=a.renderer.pixelToScreenCoordinates(t,u),o=v,g;if(a.$mouseHandler.$enableJumpToDef)q&&i||j&&i?g="add":i&&(g="block");else if(j&&!i){if(g="add",!d&&n)return}else i&&(g="block");g&&(x.isMac&&f.ctrlKey)&&a.$mouseHandler.cancelContextMenu();if("add"==g){if(d||!s){if(!d){var h=c.toOrientedRange();a.addSelectionMarker(h)}var w=
c.rangeList.rangeAtPoint(r);a.$blockScrolling++;a.inVirtualSelectionMode=!0;n&&(w=null,h=c.ranges[0],a.removeSelectionMarker(h));a.once("mouseup",function(){var b=c.toOrientedRange();w&&b.isEmpty()&&m(w.cursor,b.cursor)?c.substractPoint(b.cursor):(n?c.substractPoint(h.cursor):h&&(a.removeSelectionMarker(h),c.addRange(h)),c.addRange(b));a.$blockScrolling--;a.inVirtualSelectionMode=!1})}}else if("block"==g){b.stop();a.inVirtualSelectionMode=!0;var k,e=[];a.$blockScrolling++;d&&!j?c.toSingleRange():
!d&&j&&(k=c.toOrientedRange(),a.addSelectionMarker(k));n?v=y.documentToScreenPosition(c.lead):c.moveToPosition(r);a.$blockScrolling--;o={row:-1,column:-1};z.capture(a.container,l,function(){clearInterval(p);a.removeSelectionMarkers(e);e.length||(e=[c.toOrientedRange()]);a.$blockScrolling++;k&&(a.removeSelectionMarker(k),c.toSingleRange(k));for(var b=0;b<e.length;b++)c.addRange(e[b]);a.inVirtualSelectionMode=!1;a.$mouseHandler.$clickSelection=null;a.$blockScrolling--});var p=setInterval(function(){var b=
a.renderer.pixelToScreenCoordinates(t,u),d=y.screenToDocumentPosition(b.row,b.column);if(!m(o,b)||!m(d,c.lead))o=b,a.$blockScrolling++,a.selection.moveToPosition(d),a.renderer.scrollCursorIntoView(),a.removeSelectionMarkers(e),e=c.rectangularRangeBlock(o,v),a.$mouseHandler.$clickSelection&&(1==e.length&&e[0].isEmpty())&&(e[0]=a.$mouseHandler.$clickSelection.clone()),e.forEach(a.addSelectionMarker,a),a.updateSelectionMarkers(),a.$blockScrolling--},20);return b.preventDefault()}}}});